/*
 DSPRobotics
 PIC Clicker RS485 - HID  DMX512 V1.00    (PIC Clicker)
 Language: Mikro C Pro
 Chip: P18F47J53
 CLK: 48Mhz

 Aplication: Ideal for using with the FlowStone Graphical Programming Language.
http://www.dsprobotics.com/

*/
/*---------------------------------------------------------------*/
// USB
unsigned char readbuff[64] absolute 0x500;   // Buffers should be in USB RAM, please consult datasheet
unsigned char writebuff[64] absolute 0x540;

char cnt;
char kk;
char i,j;

// pin definitions
sbit LD1 at LATA0_bit;    //LED 1
sbit LD2 at LATA1_bit;    //LED 2
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;   //Button 1
sbit T2 at RD2_bit;   //Button 2
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

sbit RW at LATC6_bit;   //Set RS485 R/T to T
sbit RW_Direction at  TRISC6_bit;  //Output

sbit Tx at RD6_bit; //TX pin
sbit Tx_Direction at TRISD6_bit;    //Tx Direction
/*---------------------------------------------------------------*/
// Interrupt routine
void interrupt() {

  USB_Interrupt_Proc();                   // USB servicing is done inside the interrupt
}
/*---------------------------------------------------------------*/
void clear_USB_buffers()
{
   for (i=0; i<63;i++)
   {
   readbuff[i] = 0;
   writebuff[i] = 0;
   }
}
/*---------------------------------------------------------------*/
void delay_4us()
{
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
 asm{nop};
}
/*---------------------------------------------------------------*/
void write_headder()
{
 Tx  = 0;         //Break
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 Tx  = 1;          //MBB
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
 delay_4us();
}
/*---------------------------------------------------------------*/
void write_byte(char byte)
{
  Tx = 0;       //Start Bit
  delay_4us();
  if (byte.F0 == 0x00) {
   Tx = 0;       //Bit 0
  }else {
  Tx = 1;
  }
  delay_4us();
  if (byte.F1 == 0x00) {
   Tx = 0;       //bit 1
  }else {
    Tx = 1;
  }
  delay_4us();
  if (byte.F2 == 0x00) {
   Tx = 0;       //bit 2
  }else {
    Tx = 1;
  }
  delay_4us();
  if (byte.F3 == 0x00) {
   Tx = 0;       //bit 3
  }else {
    Tx = 1;
  }
  delay_4us();
  if (byte.F4 == 0x00) {
   Tx = 0;       //bit 4
  }else {
    Tx = 1;
  }
  delay_4us();
    if (byte.F5 == 0x00) {
   Tx = 0;       //bit 5
  }else {
    Tx = 1;
  }
  delay_4us();
    if (byte.F6 == 0x00) {
   Tx = 0;       //bit 6
  }else {
    Tx = 1;
  }
  delay_4us();
    if (byte.F7 == 0x00) {
   Tx = 0;       //bit 7
  }else {
    Tx = 1;
  }
  delay_4us();
  Tx = 1;
  delay_4us();
  delay_4us();
  delay_4us();    //2 x stopp bits
}
/*---------------------------------------------------------------*/
void main(){
  long cnt = 0;

  ANCON0 = 0xFF;               // Default all pins to digital
  ANCON1 = 0x1F;
  TRISD = 0;
  TRISC = 0;
  TRISB = 0;
  TRISA = 0;
  RCSTA1=1;

  T1_Direction = 1;         // Set direction for buttons
  T2_Direction = 1;

  LD1_Direction = 0;        // Set direction for LEDS
  LD2_Direction = 0;
  LD1 = 0;                  // turn off leds
  LD2 = 0;
  
  RW = 0; //RS485 Read
  RW_Direction = 0; // Output
  Tx_Direction = 0; //Output
  
  clear_USB_buffers();

  Delay_ms(100);

  HID_Enable(&readbuff,&writebuff);       // Enable HID communication
 /*---------------------------------------------------------------*/
  while (1){
   cnt++;

   if (cnt > 5000) {

      LD1 = ~LD1;      //Toggle LED 1
      //RD6Pin = ~RD6Pin;      //Toggle LED 1
      cnt = 0;         //Reset Counter
      GIE_bit = 0;                         // Disable all interrupts
      //DMX String
      RW = 1;     //Write
      write_headder();
      write_byte(readbuff[0]);  //Should be 0x00
      write_byte(readbuff[1]);
      write_byte(readbuff[2]);
      write_byte(readbuff[3]);
      write_byte(readbuff[4]);
      write_byte(readbuff[5]);
      write_byte(readbuff[6]);
      write_byte(readbuff[7]);
      write_byte(readbuff[8]);
      RW = 0; //RS485 hiZ
      GIE_bit = 1;                         // enable all interrupts
     }
  /*---------------------------------------------------------------*/
    //USB
     kk = HID_Read();
     if (kk != 0)
     {
     HID_Write(&readbuff,64);
     }
   /*---------------------------------------------------------------*/
  }
}